//
//  ENCardProcessingRequest.h
//  ENCardScan
//
//  Created by Tong Liu on 6/21/13.
//  Copyright (c) 2013 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface ENCardProcessingRequest : NSObject {
  NSString *mNoteUUID;
  NSArray *mCardImages;
  NSArray *mImageHashes;
  
  NSString *mAuthToken;
  
  BOOL mProcessImageForOCR;
  NSString *mRecoLanguage;
  
  BOOL mSkipNoteGeneration;
}

@property (copy) NSString *noteUUID;        // unique identifier of the original note, could be a local GUID or syned GUID
@property (retain) NSArray *cardImages;     // an array of NSImage's to process
@property (retain) NSArray *imageHashes;    // an array of NSData hashes (lower hex digits) for the card images

@property (copy) NSString *authToken;       // needed to talk to card reco service
@property (assign) BOOL processImageForOCR; // if YES, the image will go through BCTransform for edge detection and other enhancements
@property (copy) NSString *recoLanguage;    // default to nil ("en"), set to UI language of the client

@property (assign) BOOL skipNoteGeneration; // default to NO; if YES, will ENCardProcessingOperation will set ENBusinessCard in ENCardProcessingResponse,
                                            // and won't generate ENHelloContact and enmlContent

- (id)initWithNoteUUID:(NSString *)noteUUID
            cardImages:(NSArray *)cardImages
           imageHashes:(NSArray *)imageHashes
             authToken:(NSString *)authToken
    processImageForOCR:(BOOL)process;

@end
