//
//  ENSocialSearchRequest.h
//  SocialSearch
//
//  Created by Eric Cheng on 7/16/13.
//  Copyright (c) 2013 Evernote Corp. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum {
    ENSocialSearchTypeLinkedIn            = (1 << 0),
    ENSocialSearchTypeFacebook            = (1 << 1),
    ENSocialSearchTypeLinkedInFacebook    = (1 << 0) | (1 << 1),
    ENSocialSearchTypeAddressBook         = (1 << 2),
    ENSocialSearchTypeLinkedInAddressBook = (1 << 0) | (1 << 2),
    ENSocialSearchTypeFacebookAddressBook = (1 << 1) | (1 << 2),
    ENSocialSearchTypeDefault             = (1 << 0) | (1 << 1) | (1 << 2)
} ENSocialSearchType;

@interface ENSocialSearchRequest : NSObject {
    NSString *_firstName;
    NSString *_lastName;
    NSString *_emailAddress;
    NSString *_publicURL;
    NSString *_requestID;
    ENSocialSearchType _searchType;
}

@property (copy) NSString *firstName;
@property (copy) NSString *lastName;
@property (copy) NSString *emailAddress;
@property (copy) NSString *publicURL;
@property (copy) NSString *requestID;

/*
 * Clients may set this property to configure the search sources
 */
@property (assign) ENSocialSearchType searchType;

- (id)initWithFirstName:(NSString *)firstName lastName:(NSString *)lastName;
- (id)initWithEmailAddress:(NSString *)emailAddress;
- (id)initWithPublicURL:(NSString *)publicURL;

@end
