//
//  ENSocialSearchResponse.h
//  SocialSearch
//
//  Created by Eric Cheng on 7/16/13.
//  Copyright (c) 2013 Evernote Corp. All rights reserved.
//

#import <Foundation/Foundation.h>

@class ENSocialProfile;

@interface ENSocialSearchResponse : NSObject {
    ENSocialProfile *_mergedSocialProfile;
    NSString *_requestID;
    NSMutableDictionary *_errorsMap;
}

@property (retain, readonly) ENSocialProfile *mergedSocialProfile;
@property (retain, readonly) NSString *requestID;

/**
 * an dictionary storing all errors occurred in the search
 * error keys are defined in ENSocialSearchError.h
 */
@property (retain, readonly) NSMutableDictionary *errorsMap;

- (id)initWithSocialProfileMap:(NSDictionary *)socialProfileMap;

@end
